/// Problem  : Phisics of Khottabych (School Vladivostok Olympiad 2006-2007)
/// Solution : Igor V. Burago
/// Modified : 17.11.06

#include <cstdio>
#include <cstring>
#include <cassert>
#include <cmath>
#include <algorithm>
using namespace std;

typedef double real;
#define REAL_SCANF "%lf"

#define MAX_N 1001
#define EPS 1e-10
#define SQR(x) ((x)*(x))

int cmp(real a, real b)
{
  if (abs(a - b) < EPS) return 0;
  else if (a < b) return -1;
  else return 1;
}

int n, Enear, Efar, ans;
int xs[MAX_N], ys[MAX_N], vx[MAX_N], vy[MAX_N];
bool good[MAX_N];
struct answer
{
  real t;
  int x, y;

  bool operator < (const answer &z)
  {
    return cmp(abs(t), abs(z.t)) < 0 || (cmp(abs(t), abs(z.t)) == 0 && t < z.t);
  }
} moments[MAX_N*MAX_N];
int links[MAX_N];
real L, T;
int incompany, cnt;

int main()
{
  freopen("input.txt", "rt", stdin);
  freopen("output.txt", "wt", stdout);

  int i, j;

  scanf("%d%d%d"REAL_SCANF REAL_SCANF, &n, &Enear, &Efar, &L, &T);
  assert(1 <= n && n <= 1000);
  assert(0 <= Enear && Enear <= 1000);
  assert(0 <= Efar && Efar <= 1000);
  assert(0 <= L && L <= 1000);
  assert(0 <= T && T <= 1000);
  for (i = 0; i < n; i++)
  {
    scanf("%d%d%d%d", &xs[i], &ys[i], &vx[i], &vy[i]);
    assert(-1000 <= xs[i] && xs[i] <= 1000);
    assert(-1000 <= ys[i] && ys[i] <= 1000);
    assert(-1000 <= vx[i] && vx[i] <= 1000);
    assert(-1000 <= vy[i] && vy[i] <= 1000);
  }
  
  memset(good, 0, sizeof good);

  ans = 0;
  for (i = 0; i < n; i++)
    for (j = i+1; j < n; j++)
    {
      bool ok = cmp(SQR(xs[i] - xs[j]) + SQR(ys[i] - ys[j]), L*L) <= 0;
      good[i] = good[i] || ok;
      good[j] = good[j] || ok;
    }
  for (i = 0; i < n; i++)  
    ans += (good[i] ? Enear : Efar);

  cnt = 0;
  incompany = 0;
  memset(links, 0, sizeof links);
  for (i = 0; i < n; i++)
    for (j = i+1; j < n; j++)
    {
      real a, b, c, d, t1, t2;
      
      a = SQR(vx[i] - vx[j]) + SQR(vy[i] - vy[j]);
      b = 2*((xs[i] - xs[j])*(vx[i] - vx[j]) + (ys[i] - ys[j])*(vy[i] - vy[j]));
      c = SQR(xs[i] - xs[j]) + SQR(ys[i] - ys[j]) - L*L;

      if (a == 0)
      { /* equal speed */
        if (cmp(SQR(xs[i] - xs[j]) + SQR(ys[i] - ys[j]), L*L) <= 0)
          incompany += (links[i]++ == 0) + (links[j]++ == 0);
        continue;
      }
      if (cmp(d = b*b - 4*a*c, 0) < 0) continue;

      t1 = max(0.0, 0.5*(-b - sqrt(d))/a);
      t2 = max(0.0, 0.5*(-b + sqrt(d))/a);
      if (cmp(t1 + t2, 0) == 0) continue;

      if (cmp(t1, 0) == 0)
        incompany += (links[i]++ == 0) + (links[j]++ == 0);
      else
        if (cmp(t1, T) <= 0)
        {
          moments[cnt].t = -t1;
          moments[cnt].x = i;
          moments[cnt++].y = j;
        }
      if (cmp(t2, T) <= 0)
      {
        moments[cnt].t = +t2;
        moments[cnt].x = i;
        moments[cnt++].y = j;
      }
    }
  ans = max(ans, incompany*Enear + (n - incompany)*Efar);
  
  sort(moments, moments + cnt);

  for (i = 0; i < cnt; i++)
  {
    if (moments[i].t < 0)
      incompany += (links[moments[i].x]++ == 0) + (links[moments[i].y]++ == 0);
    else
      incompany -= (links[moments[i].x]-- == 1) + (links[moments[i].y]-- == 1);
    ans = max(ans, incompany*Enear + (n - incompany)*Efar);    
  }

  printf("%d", ans);

  return 0;
}