#include <iostream>
#include <cmath>
#include <iomanip>

using namespace std;

#pragma comment(linker,"/stack:30000000")

#define SQR(x) ((x)*(x))

typedef long double real;

const int maxn = 1010;
const int maxk = 2*maxn*maxn;
const int eps = 1e-12;

int x[maxn],y[maxn],vx[maxn],vy[maxn];
real t,r;
int k,e,u,num,num1;
real t1[maxk];
int p1[maxk],p2[maxk],kind[maxk],ans,vis[maxn],n;
int vis1[maxn];

void AddEv(real a, real b, int i, int j)
{
   if (a > t || b < 0) return;
   if (a > 0) {
      n++; t1[n] = a; p1[n] = i; p2[n] = j; kind[n] = 1; 
   }
   n++; t1[n] = b; p1[n] = i; p2[n] = j; kind[n] = -1;
}

int Less(real t1, int k1, real t2, int k2)
{
   if (t1 == t2) return k1 > k2; else return t1 < t2;
}

void Qsort(int l, int r)
{
   if (l >= r) return;
   int i = l,j = r;
   int k1 = rand()%(r-l+1) + l;
   real k = t1[k1]; k1 = kind[k1];
   while (i < j) {
      while (Less(t1[i],kind[i],k,k1)) i++;
      while (Less(k,k1,t1[j],kind[j])) j--;
      if (i <= j) {
         swap(t1[i],t1[j]); swap(p1[i],p1[j]); swap(p2[i],p2[j]); 
         swap(kind[i],kind[j]);
         i++; j--;
      }
   }
   if (l < j) Qsort(l,j);
   if (i < r) Qsort(i,r);
}

int Go(real t)
{
   int i,j,num;
   memset(vis1,0,sizeof(vis1));
   for (i = 1; i <= k; i++)
      for (j = i+1; j <= k; j++)
         if (SQR(x[i]+vx[i]*t-x[j]-vx[j]*t)+SQR(y[i]+vy[i]*t-y[j]-vy[j]*t)<=SQR(r)) {
           vis1[i]++; vis1[j]++;
         }
   num = 0;
   for (i = 1; i <= k; i++) if (vis1[i]) num++;
   num1 = num;
   return e*num + u*(k-num);
}

int main()
{
   int i,j,a1;
   real a,b,c,d,tmp,tans;
   
   srand(7422698);
   freopen("input.txt","rt",stdin); freopen("output.txt","wt",stdout);
   cin >> k >> e >> u >> r >> t;
   for (i = 1; i <= k; i++) cin >> x[i] >> y[i] >> vx[i] >> vy[i];

   for (i = 1; i < k; i++)
      for (j = i+1; j <= k; j++) {
         a1 = SQR(vx[i]-vx[j]) + SQR(vy[i]-vy[j]);
         if (a1) {
            a = a1;
            b = 2 * ((vx[i]-vx[j])*(x[i]-x[j]) + (vy[i]-vy[j])*(y[i]-y[j]));
            c = SQR(x[i]-x[j]) + SQR(y[i]-y[j]) - SQR(r);
            d = b*b - 4*a*c;
            if (d >= 0.0) {  
               d = sqrt(fabsl(d)); 
               AddEv((-b-d)/2/a,(-b+d)/2/a,i,j);
            }
         }
      }

   Qsort(1,n); ans = Go(0); num = num1;
   memcpy(vis,vis1,sizeof(vis));
   t1[0] = 0;
   for (i = 1; i <= n; i++) {
      if (t1[i] > t) break;
      if (kind[i] > 0) {
         if (!vis[p1[i]]) num++; if (!vis[p2[i]]) num++;
         vis[p1[i]]++; vis[p2[i]]++;
      } else {
         vis[p1[i]]--; vis[p2[i]]--;
         if (!vis[p1[i]]) num--; if (!vis[p2[i]]) num--;
      }
      if (e*num + u*(k-num) > ans) ans = e*num + u*(k-num);
   }
   tmp = Go(t); if (tmp > ans) ans = tmp;

   cout << ans << endl;
   fclose(stdin); fclose(stdout);
   return 0;
}
